USE AdventureWorks
GO

CREATE MASTER KEY
       ENCRYPTION BY PASSWORD = N'D8CT93u8XAr4ctcBopX7V7dm';
GO

CREATE USER INST02User WITHOUT LOGIN;
GO

CREATE CERTIFICATE INST02Certificate
     AUTHORIZATION INST02User
     WITH SUBJECT = N'INST02 Certificate',
          EXPIRY_DATE = N'12/31/2012';
GO

BACKUP CERTIFICATE INST02Certificate
  TO FILE = N'E:\Certs\INST02Certificate.cer';
GO

USE [MASTER] 
ALTER DATABASE [AdventureWorks] SET NEW_BROKER
GO

USE AdventureWorks
GO

CREATE MESSAGE TYPE [//PortalSync/Sync/HumanResourcesEmployee] 
AUTHORIZATION dbo 
VALIDATION = WELL_FORMED_XML
GO

CREATE MESSAGE TYPE [//PortalSync/Sync/PersonContact] 
AUTHORIZATION dbo 
VALIDATION = WELL_FORMED_XML
GO

CREATE MESSAGE TYPE [//PortalSync/Sync/PurchasingVendor] 
AUTHORIZATION dbo 
VALIDATION = WELL_FORMED_XML
GO

CREATE CONTRACT [//PortalSync/Sync/SyncContract]
	AUTHORIZATION dbo 
	( [//PortalSync/Sync/HumanResourcesEmployee] SENT BY ANY, 
	  [//PortalSync/Sync/PersonContact] SENT BY ANY,
      [//PortalSync/Sync/PurchasingVendor] SENT BY ANY )
GO

CREATE QUEUE INST02Queue
   WITH 
   STATUS = ON,
   RETENTION = OFF 
GO

CREATE SERVICE [//INST02Site/Sync/INST02Service] 
AUTHORIZATION INST02User 
ON QUEUE INST02Queue
GO

USE [master];
GO

IF EXISTS 
(SELECT * 
	FROM sys.endpoints
	WHERE name = N'INST02Endpoint')
	
	DROP ENDPOINT INST02Endpoint;
GO

CREATE ENDPOINT INST02Endpoint
STATE = STARTED
AS TCP ( LISTENER_PORT = 4023 )
FOR SERVICE_BROKER (AUTHENTICATION = WINDOWS );
GO
GRANT CONNECT ON ENDPOINT::[INST02Endpoint] to [SQLTBWS\sqlexec]
GO
